package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.dao.TaUserMapper;
import com.community.huiju.dao.ToSysRoleMapper;
import com.community.huiju.dao.ToUserMapper;
import com.community.huiju.model.TaUser;
import com.community.huiju.model.ToSysRole;
import com.community.huiju.model.ToUser;
import com.community.huiju.service.IToSysRoleService;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service("iToSysRoleService")
@Slf4j
public class ToSysRoleServiceImpl implements IToSysRoleService {

    @Autowired
    private ToSysRoleMapper toSysRoleMapper;

    @Autowired
    private ToUserMapper toUserMapper;

    @Override
    public List<ToSysRole> selectRoleByUserId(Integer userId) {

        return toSysRoleMapper.selectRoleByUserId(userId);
    }

    @Override
    public ResponseBean getAll(String parameter) {
        ResponseBean responseBean = new ResponseBean();

        JSONObject jsonObject = JSONObject.parseObject(parameter);
        Integer pageNum = jsonObject.getInteger("pageNum");
        Integer pageSize = jsonObject.getInteger("pageSize");
        String roleName = jsonObject.getString("roleName").trim();

        Page<ToSysRole> pageInfo = PageHelper.startPage(pageNum, pageSize);
        List<ToSysRole> roleList = toSysRoleMapper.selectAll(roleName);
        roleList.forEach(e -> {
            ToUser createUser = toUserMapper.selectByPrimaryKey(e.getCreateUser());
            ToUser updateUser = toUserMapper.selectByPrimaryKey(e.getUpdateUser());
            e.setCreateUserName(createUser.getUserName());
            e.setUpdateUserName(updateUser.getUserName());
        });

        Map<String, Object> resMap = new HashMap<>();
        resMap.put("list", roleList);
        resMap.put("pageNum", pageInfo.getPageNum());
        resMap.put("pageSize", pageInfo.getPageSize());
        resMap.put("total", pageInfo.getTotal());


        responseBean.addSuccess(resMap);
        return responseBean;
    }
}
