package com.community.huiju.service.impl;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.community.commom.mode.ResponseBean;
import com.community.commom.session.UserElement;
import com.community.huiju.dao.RoleMapper;
import com.community.huiju.model.SysRole;
import com.community.huiju.model.TpTransaction;
import com.community.huiju.service.RoleServiceI;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author FXF
 * @date 2019-01-16
 */
@Service("roleService")
@Slf4j
public class RoleServiceImpl extends ServiceImpl<RoleMapper, SysRole> implements RoleServiceI {
	
	@Autowired
	private RoleMapper roleMapper;
	/**
	 * 获取角色列表
	 *
	 * @param roleName
	 * @param userElement
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	@Override
	public ResponseBean getRoleList(String roleName, UserElement userElement, Integer pageNum, Integer pageSize) {
		ResponseBean responseBean = new ResponseBean();
		Page page = new Page(pageNum,pageSize);
		// 分页查询
		SysRole role = new SysRole();
		role.setRoleName(roleName);
		role.setCommunityId(userElement.getCommunityId());
		List<TpTransaction> list = roleMapper.getRoleListByParams(page,role);
		Map<String, Object> map = Maps.newHashMap();
		map.put("list",list);
		map.put("total",page.getTotal());
		responseBean.addSuccess(map);
		return null;
	}
}
